-- Global Definitions -------------------------------------------------------

-- Dialog Box Active Bits-----------------------------------------------------

--1  normal active flag, set when dlg not covered
--2  if set, auto remove dlg at end of dsptch
--3  do not remove when parent is removed
--4  do not make inactive when bringing up child
--5  overrides function of xtra_active bit in field
--6  if set, automatically remove dlg when cursor moves outside of dlg
--7  if set then automatically grey fields when field normal_active bit
--   is cleared and extra_active is not set and automatically when field
--   normal_active bit is set ungrey
--8  if set then automatically set normal_active bit for all fields in this
--   dlg to 1 whenever no other dlg boxes are over this dlg box, 0 otherwise
--9  if set then automatically set the dlg normal_active bit when the cursor
--   moves into the dlg box
--10 if set then automatically clear normal_active bit when the cursor
--   moves out of the dlg box
--11 if set then automatically set all fields normal_active bit when
--   the cursor moves into the dlg box
--12 if set then automatically clear all fields normal_active bit when
--   the cursor moves out of the dlg box (xtra_active will override this)

--Field Active Bits----------------------------------------------------------

--1 normal active flag, set when dlg not covered
--2 if set, then do not allow field normal active flag to go off
--3 overrides function of the auto_grey dlg bit
--4 if set then this is a dummy field, not pickable, just for storing values
--5 if set enable character wrap for text field
--6 if set enable word wrap for text field
--7 if set enable vertical scrolling for text field
--8 if set enable horizontal scrolling for text field
--9 if set enable display of text cursor in field when the field is active

--Some standard acitve bit settings------------------------------------------

define normal_active$      "1" --normal active flag, set when dlg not covered
define bnormal_active$     "0b10000000000"

define mp_style_active$
       "active 0b110000100001"

define mp_style_activex$
       "active 0b110000100000"

define stay_up_active$
       "active 0b101000110000"

define stay_up_activex$
       "active 0b101100110000"

define button_push$
       "active 0b10000000001"

--Cursors--------------------------------------------------------------------

define fld_arrow$       "5"
define inactive_cur$    "42"
define move_cur$        "43"
define dlg_arrow$       "44"
define hand_cur$        "45"
define no_pick_arrow$   "46"
define no_can_do_cur$   "47"
define edit_cur$        "48"
define hand_no_finger$  "49"
define pin_cur$         "50"

--Default DLG and FLD Parameters---------------------------------------------

cur_style fld_arrow
cur_color 15
hlight_color 00
bkg_color 23    -- 7
fgr_color 16    -- 0
position 5
active bnormal_active

--System Variables-----------------------------------------------------------

define edt_box$         "fldiv(menu_opt_box,801)"

define rad_to_deg$      "57.2957795"

define no_hilight$       "hlight_color 0"
define hilight$          "hlight_color 15"

define in_vnp$          "i_var(1457) = 1"
define not_in_vnp$      "i_var(1457) <> 1"
define in_mp$           "i_var(1457) = 3"
define not_in_mp$       "i_var(1457) <> 3"
define in_getdata$      "i_var(1457) >= 4"
define not_in_getdata$  "i_var(1457) < 4"
define in_dig_mode$     "i_var(1457) = 4"
define not_in_dig_mode$ "i_var(1457) <> 4"
define in_end_mode$     "i_var(1457) = 5"
define not_in_end_mode$ "i_var(1457) <> 5"
define in_ent_mode$     "i_var(1457) = 7"
define not_in_ent_mode$ "i_var(1457) <> 7"
define vnphlp$          "i_var(16)"
define mphlp$           "i_var(17)"
define dighlp$          "i_var(18)"

--Functions------------------------------------------------------------------

define do_fld_dig$ "exec_fld_cmd(-1,-1,-2)"

define push_in$  "1,8,15,0"
define pop_out$  "0,8,15,8"

define     islide_val$   "fldiv(islide_box,701)"
define set_islide_min$   "set_fldiv(islide_box,700,"
define set_islide_val$   "set_fldiv(islide_box,701,"
define set_islide_max$   "set_fldiv(islide_box,702,"

define set_xy_position1$
"if d_box_level(assist_box) > 0 then
 if fldiv(menu_opt_box,701) = 1 or fldiv(menu_opt_box,701) = 4 then
  set_position(3,1,3,assist_box,0) --puts dlg on left edge of assist box
 else
  set_position(1,3,3,assist_box,0) --puts dlg on right edge of assist box
 endif
elseif d_box_level(main_box) > 0 then
 if fldiv(menu_opt_box,701) = 1 or fldiv(menu_opt_box,701) = 4 then
  set_position(3,1,3,main_box,0) --puts dlg on left edge of main box
 else
  set_position(1,3,3,main_box,0) --puts dlg on right edge of main box
 endif
else"
define set_xy_position2$
"if fldiv(menu_opt_box,701) = 1 then
  set_position(3,3,1,0,0)
 elseif fldiv(menu_opt_box,701) = 2 then
  set_position(1,1,1,0,0)
 elseif fldiv(menu_opt_box,701) = 3 then
  set_position(7,7,1,0,0)
 else
  set_position(9,9,1,0,0)
 endif
endif"

define lay_lc1$
"do_fld_dig
 if biti(405,1) = 1 then
  set_i_var(3001,fldiv(-1,-1))
  set_fldiv(-1,"

define lay_lc2$
",layer_color(3001))
  exec_fld_cmd(-1,"

define lay_lc3$ ",-8) endif"

--define lay_lc1$ "do_fld_dig --"
--define lay_lc2$ "--"
--define lay_lc3$ "--"

define col_lc1$ "set_i_var(3001,mpv("

--the if statement in the following line is to fix color clobbering by pm routines
--define col_lc2$ ")) set_fldiv(-1,-1,layer_color(3001)) if fldiv(-1,-1) < 1 then set_fldiv(-1,-1,7) set_i_var(1425,7) endif"
define col_lc2$ ")) set_fldiv(-1,-1,layer_color(3001))"

--define col_lc1$ "--"
--define col_lc2$ "--"

define     page_base$ "i_var(3006)"
define set_page_base$ "set_i_var(3006,"

define microDRAFT$ "i_var(68) <> 3"

define menu_clear$ "
if fldiv(top_bar,250) > 0 then
 d_box_del(fldiv(top_bar,250))
 if fldiv(top_bar,250) = mnu4a_box then
  push_button(tb04_box,0,pop_out)
 elseif fldiv(top_bar,250) = mnu5a_box or fldiv(top_bar,250) = mnu5b_box then
  push_button(tb05_box,0,pop_out)
 else
  push_button(fldiv(top_bar,250)-100,0,pop_out)
 endif
endif"

define set_dparent_active$ "set_dlg_active(dlg_dparent(-1), normal_active)"

define pop_mnu$ "menu_clear set_fldiv(top_bar,250,0)"

define graphics_x_min$  "i_var(71)"
define graphics_y_min$  "i_var(72)"
define graphics_x_max$  "i_var(73)"
define graphics_y_max$  "i_var(74)"

define half_way$        "i_var(77)/2"
define screen_x_min$    "i_var(75)"
define screen_y_min$    "i_var(76)"
define screen_x_max$    "i_var(77)"
define screen_y_max$    "i_var(78)"
define over_box$        "i_var(79)"
define over_fld$        "i_var(80)"
define over_tg$         "i_var(3010)"

define in_tb_range$     "over_box >= 2361 and over_box <= 3210"
define in_tg_range$     "over_tg >= 2361 and over_tg <= 3210"

define dig_action$      "action(1)"
define done_action$             "action(2) done_chr(32)" --done and send ' '
define done_action_null$        "action(2) done_chr(0)"
define take_down_done_action$   "action(2) done_chr(13)"
define abort_action$     "action(3)" --abort current dlg and send back ^c
define leave_action$     "action(4)"
define quit_action$      "action(5)" --abort current dlg only

define move_cur_style$   "cur_style move_cur"

define from_dbox$       "dlg_dparent(-1)"
define from_dfld$       "dlg_fparent(-1)"

define activate$        "set_fld_active(-1, 0, normal_active, 1)"
define deactivate$      "set_fld_active(-1, 0, normal_active, 0)"
define set_active_cur$  "set_dlg_cursty(-1, dlg_arrow)"
define set_inactive_cur$"set_dlg_cursty(-1, inactive_cur)"
define check_value$     "fld_value 2 2 0 1 320 319 end"
define check_mark$      "type 32 fld_value 1 2 1 0 319 320 end"
define check_mark_off$  "type 32 fld_value 2 2 1 0 319 320 end"
define box_value$       "fld_value 2 2 0 1 340 339 end"

define set_default_position$ "set_position(7,7,7,fldiv(-1,241),fldiv(-1,242))"

define pinned$          "fldiv(-1,219) = 1"
define not_pinned$      "fldiv(-1,219) = 0"

define not_summoning$   "fldiv(gd_box,1001) = 0"
define summoning$       "fldiv(gd_box,1001) = 1"

define wake_up$ "exec_fld_cmd(-1,8001,2)"

define set_clip$
"if fldiv(menu_opt_box,653) = 2 then
 set_dlg_active(-1,14,1)
else
if dlg_lx(-1) = screen_x_min or dlg_ux(-1) = screen_x_max then
 set_dlg_active(-1,14,1)
else
 set_dlg_active(-1,14,0)
endif
endif"

define dsp_home$
"if fldiv(-1,241) <> dlg_lx(-1) or fldiv(-1,242) <> dlg_ly(-1) then
  set_fldiv(-1,243,1)
 else
  set_fldiv(-1,243,2)
 endif
 dsp_fld(-1,243)"

define set_dclick$
"set_dbl_click(fldiv(menu_opt_box,301)*fldiv(menu_opt_box,303),fldiv(menu_opt_box,304))"

define set_bpush$
"set_button_push(fldiv(menu_opt_box,501),fldiv(menu_opt_box,502),fldiv(menu_opt_box,503),fldiv(menu_opt_box,504),fldiv(menu_opt_box,505))"

define mp_char$ "fldsv(sys_opt_box,9001)"

define mv_number$ "fldiv(top_bar,1001)"

define dsp_tfont$
"if fldiv(-1,-1) <= 6 then
 icon(fldiv(-1,-1)+450)
elseif fldiv(-1,-1) > 400 then
 icon(fldiv(-1,-1)+57)
else
 icon(457)
endif"

define dim_prec$
"fld_dig
if fldiv(dim_opt_box,346) = 0 then
 if fldiv(-1,-1) < 5 then
  add_fldiv(-1,-1,1)
 else
  set_fldiv(-1,-1,0)
 endif
else
 if fldiv(-1,-1) < 64 then
  set_fldiv(-1,-1,fldiv(-1,-1)/2)
  if fldiv(-1,-1) < 1 then set_fldiv(-1,-1,1) endif
  set_fldiv(-1,-1,fldiv(-1,-1)*4)
 else
  set_fldiv(-1,-1,1)
 endif
endif
dsp_fld(-1,-1)
end"

define upd_cpl$
"set_i_var(3299, i_var(12)) set_i_var(1359,0) set_i_var(1397,0) set_i_var(12,i_var(3299))"

--Buttons--------------------------------------------------------------------

define fourd$ "fld 444 type 100 fld_in_to play_icon(0,444,444,-1,-1,7,0,0,7) end fld_out_of play_icon(0,445,445,-1,-1,7,0,0,7) end"

--define savemod_button$
--"fld 225 type 100 active 0b11
--fld_dig
-- exec_dlg_cmd(-1,2)
-- send_input
-- exec_dlg_cmd(-1,5)
-- send_input
-- exec_dlg_cmd(-1,2)
-- send_input
-- set_i_var(3250,dlg_active(-1,2))
-- set_dlg_active(-1,-2,0)
-- input(' SAVEMOD #13#')
-- send_input
-- set_dlg_active(-1,-2,i_var(3250))
-- exec_dlg_cmd(-1,2)
--end"

define move_button$
"fld 220 type 100 move_cur_style active 0b11
fld_dig
 if d_box_level(-1) = 1 then
  move(-1, 10, -2)
 else
  move(-1, 10, 1) put_xh(-1,-1,5)
 endif
end"

define x_move_button1$
"fld 220 type 100 move_cur_style active 0b11
fld_dig
 if d_box_level(-1) = 1 then
  move(-1, 10, -2)
 else
  move(-1, 10, 1) put_xh(-1,-1,5)
  if pinned then set_clip endif"

define x_move_button2$
"dsp_home
endif
end"

define move_dlg_to_top$
"dlg_dig
 move(-1, 10, -2)
end"

define move_fld_to_top$
"fld 217 type 100 active 0b11
fld_dig
 move(-1, 10, -2)
end"

define dummy_100$ "type 100 active 0b0001"

define dummy_2$ "type 2 active 0b0001"

define wake_up_fld$ "fld 8001 type 100 active 0b0001"

define take_down_button$ "fld 200 type 100 active 0b11 hlight_color 15"

define minimize_button$ "fld 300 type 100 active 0b11"

define pin_down_button$
"fld 219 type 32 active 0b11
fld_value 1 2
 0 1
 328 329
end"

define x_pin_down_button$
"fld 219 type 32 active 0b11
fld_value 1 2
 0 1
 328 329
end
fld_dig
 toggle(-1,219,1) dsp_fld(-1,219)
 if fldiv(-1,219) = 1 then
  set_clip
 else
  set_dlg_active(-1,14,0)
 endif
end"

define m_pin_down_button$
"fld 219 type 32 active 0b11
fld_value 1 2
 0 1
 328 329
end
fld_dig
 toggle(-1,219,1) dsp_fld(-1,219)
 if fldiv(-1,219) = 1 then
  set_dlg_active(-1,-2,0)
 else
  set_dlg_active(-1,-2,1)"

define m_pin_end$
" endif
end"

define goto_default_position1$
"fld 240 type 100 active 0b11
fld_dig
 set_default_position
 move(-1, 10, 5)
 if pinned then set_clip endif"

define goto_default_position2$
"dsp_home
end
fld 241 dummy_2
fld 242 dummy_2"

define save_default_position1$
"fld 243 type 32 active 0b11
fld_value 1 2
 0 1
 326 327
end
fld_dsp
 dsp_home
end
fld_dig
 set_fldiv(quest_box,1001,1)
 set_fldsv(quest_box,301,get_assist_str(-1,2001,2001))
 set_i_var(3003,2102)
 d_box_add(quest_box)"

define save_default_position2$
"if fldiv(quest_box,1001) = 1 then
  set_fldiv(-1,243,2) dsp_fld(-1,243)
  set_fldiv(-1,241,dlg_lx(-1))
  set_fldiv(-1,242,dlg_ly(-1))
  if pinned then set_clip endif
 endif
end"

define lock_button$
"fld 291 type 32
fld_value 1 2
 0 1
 491 492
end"

define locked$   "fldiv(-1,291) = 1"
define unlocked$ "fldiv(-1,291) = 0"

define save_to_config$
"fld 292 type 100 button_push
fld_dig
 set_i_var(1141,over_box)
 run_upl(s_var(90)@'SAVSETUP')
 input(' ')
end"

define save_mod_pm_begin$
"fld 293 type 100 button_push
fld_dig
 set_fldiv(dlg_dparent(-1),219,1)
 exec_fld_cmd(dlg_dparent(-1),219,2)
 set_fldiv(-1,219,1)
 exec_fld_cmd(-1,219,2)
 input('NOT COLOR NOT LAYER #3#"

define save_mod_pm_end$
" ') send_input
 exec_fld_cmd(-1,0,-4)
 input('NOT COLOR NOT LAYER SAVEMOD #13#')
 send_input
 exec_dlg_cmd(-1,2)
end"

---------- PICK LIST MACROS -------------------------------------------------

-- "pick_fld" defines field 260 (the pick-list field) as string data type,
-- having the pointing hand cursor, and individual line lilighing.
-- also, the dummy field 1260 is defined to hold the "page" of the pick list
-- field 1260 is referenced in the macros "calc_pick", "page_up", and
-- the "page_down" / "end_page_down" pair of macros

define pick_fld$
"fld 1260 dummy_2
fld_begin
 set_fldiv(-1,-1,0)
end
fld 260 type 1 hlight_color 15000 cur_style hand_cur"

-- "calc_pick" will calculate the element (or line number) when
-- pick is made on a pick-list.

define calc_pick$ "(xh_yc(prt_pick,260,1)/-20)+(fld_nrow(-1,260)*fldiv(-1,1260))+1"

-- "page_up" is a totally self-contained macro that defines the page-up
-- button (field 261 is used)

define page_up$
"fld 261 type 100
fld_dig
 if fldiv(-1,1260) > 0 then
  scrl_fld(-1,260,-fld_nrow(-1,260))
  add_fldiv(-1,1260,-1)
 endif
end"

-- "page_down" and "end_page_down" are a pair of macros that define
-- the button that causes the pick list field 260 (pick_fld) to
-- scroll down by one page (field 262 is used)
-- WARNING --
-- these two macros MUST be used together and separated by something
-- that indicates the total number of elements (separated by <CR>s)
-- in the pick-list
-- example:   page_down  i_var(3100)  end_page_down
-- where i_var(3100) contains the number of elements (or lines)

define page_down$
"fld 262 type 100
fld_dig
 if (fldiv(-1,1260)+1)*fld_nrow(-1,260) <"

define end_page_down$ "then
  scrl_fld(-1,260,fld_nrow(-1,260))
  add_fldiv(-1,1260,1)
 endif
end"

